#ifdef GL_ES
precision mediump float;
#endif

varying vec2 v_texCoord;
uniform sampler2D u_texture;						
//uniform vec2 tcOffset[25];// Texture coordinate offsets	
// Set up texture sampling offset storage					
int type = 3;

vec2 tcOffset[25];

void initOffset(float windowWidth,float windowHeight,float step)
{
	float i = 0.0;
	int temp = 0;
	
	float xInc = step / 5*(windowWidth);
	float yInc = step / 5*(windowHeight);
	
	while(i < 5.0 )
	{
		float j = 0.0;
		while(j < 5.0)
		{
			tcOffset[temp] = vec2((-2.0 * xInc) + (5.0 * i * xInc),(-2.0 * yInc) + (5.0*j * yInc));
			j+=1.0;
			temp++;
		}
		i += 1.0;
	}
}

void main(void)							
{	
	tcOffset[0] = vec2(0.00097656300000 ,0.00078125000000 );
	tcOffset[1] = vec2(0.00097656300000 ,0.00208333300000 );
	tcOffset[2] = vec2(0.00097656300000 ,0.00338541700000 );
	tcOffset[3] = vec2(0.00097656300000 ,0.00468750000000 );
	tcOffset[4] = vec2(0.00097656300000 ,0.00598958300000 );
	tcOffset[5] = vec2(0.00195312500000 ,0.00078125000000 );
	tcOffset[6] = vec2(0.00195312500000 ,0.00208333300000 );
	tcOffset[7] = vec2(0.00195312500000 ,0.00338541700000 );
	tcOffset[8] = vec2(0.00195312500000 ,0.00468750000000 );
	tcOffset[9] = vec2(0.00195312500000 ,0.00598958300000 );
	tcOffset[10] = vec2(0.00292968800000 ,0.00078125000000 );
	tcOffset[11] = vec2(0.00292968800000 ,0.00208333300000 );
	tcOffset[12] = vec2(0.00292968800000 ,0.00338541700000 );
	tcOffset[13] = vec2(0.00292968800000 ,0.00468750000000 );
	tcOffset[14] = vec2(0.00292968800000 ,0.00598958300000 );
	tcOffset[15] = vec2(0.00390625000000 ,0.00078125000000 );
	tcOffset[16] = vec2(0.00390625000000 ,0.00208333300000 );
	tcOffset[17] = vec2(0.00390625000000 ,0.00338541700000 );
	tcOffset[18] = vec2(0.00390625000000 ,0.00468750000000 );
	tcOffset[19] = vec2(0.00390625000000 ,0.00598958300000 );
	tcOffset[20] = vec2(0.00488281300000 ,0.00078125000000 );
	tcOffset[21] = vec2(0.00488281300000 ,0.00208333300000 );
	tcOffset[22] = vec2(0.00488281300000 ,0.00338541700000 );
	tcOffset[23] = vec2(0.00488281300000 ,0.00468750000000 );
	tcOffset[24] = vec2(0.00488281300000 ,0.00598958300000 );
	
	// Standard							
	if(type ==0)							
	{							
		gl_FragColor = texture2D(u_texture, v_texCoord);							
	}								
	// Greyscale							
	if(type ==1)							
	{							
		// Convert to greyscale using NTSC weightings							
		float grey = dot(texture2D(u_texture, v_texCoord).rgb, vec3(0.299,0.587,0.114));								
		gl_FragColor = vec4(grey, grey, grey,texture2D(u_texture, v_texCoord).a);							
	}								
	// Sepia tone							
	if(type ==2)							
	{							
		// Convert to greyscale using NTSC weightings							
		float grey = dot(texture2D(u_texture, v_texCoord).rgb, vec3(0.299,0.587,0.114));							
								
		// Play with these rgb weightings to get different tones.							
		// (As long as all rgb weightings add up to 1.0 you won't lighten or darken the image)							
		gl_FragColor = vec4(grey * vec3(1.2,1.0,0.8),texture2D(u_texture, v_texCoord).a);							
	}							
								
	// Negative							
	if(type ==3)							
	{							
		vec4 texMapColour = texture2D(u_texture, v_texCoord);							
									
		gl_FragColor = vec4(1.0 - texMapColour.rgb,texMapColour.a);							
	}							
		
	
	// Blur (gaussian)							
	if(type ==4)							
	{							
		vec4 sample[25];							
									
		for(int i =0; i <25; i++)							
		{							
			// Sample a grid around and including our texel							
			sample[i] = texture(u_texture, v_texCoord + tcOffset[i]);							
		}							
								
		// Gaussian weighting:							
		// 1 4 7 4 1							
		// 4 16 26 16 4							
		// 7 26 41 26 7 / 273 (i.e. divide by total of weightings)							
		// 4 16 26 16 4							
		// 1 4 7 4 1							
									
		gl_FragColor = (							
		(1.0* (sample[0] + sample[4] + sample[20] + sample[24])) +							
		(4.0* (sample[1] + sample[3] + sample[5] + sample[9] + sample[15] + sample[19] + sample[21] + sample[23])) +							
		(7.0* (sample[2] + sample[10] + sample[14] + sample[22])) +							
		(16.0* (sample[6] + sample[8] + sample[16] + sample[18])) +							
		(26.0* (sample[7] + sample[11] + sample[13] + sample[17])) +							
		(41.0* sample[12])							
		) /273.0;							
									
	}							
								
	// Blur (median filter)							
	if(type ==5)							
	{							
		gl_FragColor = vec4(0.0);							
									
		for(int i =0; i <25; i++)							
		{							
			// Sample a grid around and including our texel							
			gl_FragColor += texture(u_texture, v_texCoord + tcOffset[i]);							
		}							
								
		gl_FragColor /=25;							
	}							
								
	// Sharpen							
	if(type ==6)							
	{							
		vec4 sample[25];							
								
		for(int i =0; i <25; i++)							
		{							
			// Sample a grid around and including our texel							
			sample[i] = texture(u_texture, v_texCoord + tcOffset[i]);							
		}							
								
		// Sharpen weighting:							
		// -1 -1 -1 -1 -1							
		// -1 -1 -1 -1 -1							
		// -1 -1 25 -1 -1							
		// -1 -1 -1 -1 -1							
		// -1 -1 -1 -1 -1							
								
		gl_FragColor =25.0* sample[12];							
								
		for(int i =0; i <25; i++)							
		{							
			if(i !=12)							
			gl_FragColor -= sample[i];							
		}							
	}							
								
	// Dilate							
	if(type ==7)							
	{							
		vec4 sample[25];							
		vec4 maxValue = vec4(0.0);							
								
		for(int i =0; i <25; i++)							
		{							
			// Sample a grid around and including our texel							
			sample[i] = texture(u_texture, v_texCoord + tcOffset[i]);							
										
			// Keep the maximum value							
			maxValue = max(sample[i], maxValue);							
		}							
								
		gl_FragColor = maxValue;							
	}							
								
	// Erode							
	if(type ==8)							
	{							
		vec4 sample[25];							
		vec4 minValue = vec4(1.0);							
								
		for(int i =0; i <25; i++)							
		{							
			// Sample a grid around and including our texel							
			sample[i] = texture(u_texture, v_texCoord + tcOffset[i]);							
								
			// Keep the minimum value							
			minValue = min(sample[i], minValue);							
		}							
								
		gl_FragColor = minValue;							
	}							
								
	// Laplacian Edge Detection (very, very similar to sharpen filter - check it out!)							
	if(type ==9)							
	{							
		vec4 sample[25];							
								
		for(int i =0; i <25; i++)							
		{							
			// Sample a grid around and including our texel							
			sample[i] = texture(u_texture, v_texCoord + tcOffset[i]);							
		}							
								
		// Laplacian weighting:							
		// -1 -1 -1 -1 -1							
		// -1 -1 -1 -1 -1							
		// -1 -1 24 -1 -1							
		// -1 -1 -1 -1 -1							
		// -1 -1 -1 -1 -1							
									
		gl_FragColor =24.0* sample[12];							
									
		for(int i =0; i <25; i++)							
		{							
			if(i !=12)							
				gl_FragColor -= sample[i];							
		}							
	}
	/**/
}							
