#ifdef GL_ES
precision mediump float;
#endif

varying vec2 v_texCoord;
uniform sampler2D u_texture;

float pi = 3.1415926535898;
float radtodeg = 180.0/pi;
float degtorad = pi/180.0;

float border = 2.0;

float AngleBetweenPoints(vec2 src,vec2 dst){
    return atan(dst.y - src.y, dst.x - src.x) * radtodeg;
}

vec2 PolarProjection(vec2 org,float dist,float angle){
    return vec2(org.x + dist * cos(angle * degtorad),org.y + dist * sin(angle * degtorad));
}

float Distance(vec2 loc1,vec2 loc2)
{
    float dx = loc2.x - loc1.x;
	float dy = loc2.y - loc1.y;
    return sqrt(dx*dx+dy*dy);
}

void main( void ) {		
	vec4 c = texture2D(u_texture, v_texCoord);	
	
	float r = c.r;
	float g = c.g;
	float b = c.b;
	float a = c.a;
	
	if (c.a < 0.80 )
	{
		float i = 0.0;
		bool is_border = false;
	    while ( i < 6.0)
		{
			vec2 ccp = PolarProjection(v_texCoord,0.001 * border,  i * 10.0);
			
			vec4 color = texture2D(u_texture, ccp);
			float r1 = color.r;
			float g1 = color.g;
			float b1 = color.b;
			float a1 = color.a;
			
			if(a1 > 0.3)
			{
				is_border = true;
			}			
			
			i+=1.0;
		}
		
		if(is_border)
		{
			r = 1;
			b = 0.0;
			g = 0.8;
			a = 0.3;
		}
	}
		
	gl_FragColor = vec4(r,g,b,a);
	
}

